# Example PyTorch Age & Gender classification model with Integrated Explainer
Example repository of a Pytorch age and gender image classification model that uses multiple models in one and runs with Torchserve.
The model used in the example was adapted from the model in [this repository](https://github.com/manhcuong02/Pytorch-Age-Estimation/tree/main).
The model comprises two models packaged into one: one gender classification model, and one age range classification model. For explainability, the saliency attribution method from the captum library was used. The explainer is integrated into the model through the handler.py file.

This repository also serves as an example on how to package and use several models outside of the main model, as an MTCNN model is used in the preprocessing step to detect faces in the images.  

## Install the required packages
Clone this repository and navigate to the `generate_model` folder. 
Install the required packages using `pip install -r requirements.txt`
Note that these are pinned versions known to be compatible.
To be able to run `torchserve` locally make sure that Java is installed (verify with running `java --version`).

## Make model torchserve compatible
Deeploy expects all model artefects to be packaged into a single model archive file (key feature of TorchServe). To be able to serve the model with `torchserve` we need to wrap it in a `.mar` structure. 
The [torch-model-archiver](https://github.com/pytorch/serve/blob/master/model-archiver/README.md) package can take care of that.
It requires three things:

* Pytorch binary model file (`model.pt`)
* Additional files such as any dependency files (`index_to_name.json,mtcnn.py`)

The first two requirements are generated by the torch-model-archiver, the third requirement is a `handler.py` file that we need to define ourselves.
In the `handler.py` we specify how torchserve initializes the model, preprocesses the input, makes predictions and does post processing, and explain predictions (in the `get_insights` function). The `handler.py` in this repository has been customized to fit the model. To find more info on how to build a custom handler see [Custom Service](https://pytorch.org/serve/custom_service.html).

In `generate_model` folder, run `sh archive.sh`. This should create a `model.mar` file in `model_store`.

> **<span style="color:red">! </span>_NOTE:_**  When deploying the model: in [config.properties](model/config/config.properties) ensure `model_store=/mnt/models/model-store` and for `model_snapshot` machine learning model should always be named `model`. See the provided configuration file for reference.

## Run and test locally
Navigate to the `model` folder. In the config.properties file, change `model_store` variable from `/mnt/models/model-store` to `./model-store`. Then run 
```sh
export TS_SERVICE_ENVELOPE=kserve && torchserve --start --ts-config config/config.properties
``` 
in the root folder.
This will start a torchserver on port 8085.

To test it locally, change 'example_request_file.json' to your file name and run:
```sh
curl -X POST -H "Content-Type: application/json"
-d @example_request_file.json localhost:8085/v1/models/model:predict
```

## Make it Deeploy compatible
Deeploy expects the following model store layout:
```
├── model
│   ├──config
│      ├── config.properties
│   ├── model-store
│      ├── model.mar
```
Either store the files in this structure in your repo (properties file is located [here](model/config/config.properties)), or reference a storage location with this structure.

## Integrated Explainer
In this example we use a [Captum Saliency explainer](https://captum.ai/api/saliency.html) which is integrated in the model.
In the [handler](generate_model/handler.py) we need to specify the `get_insights` function, which will be used when calling the explain endpoint. 
Since the model contains two models: one for gender and one for age range detection, we have to specify which one we want to attribute. In this case we only attribute the age range model. 

To test it locally, change 'example_request_file.json' to your file name and run:
```sh
curl -X POST -H "Content-Type: application/json"
-d @example_request_file.json localhost:8085/v1/models/model:explain
```
### Visualize the output of the explainer in the Deeploy UI
In order to be able to visualize the output of the explainer in the Deeploy UI the explainer output needs to have the following structure: 

```
    "predictions": ["Array with prediction label"],
    "originals": [{"b64": "b64 encoded original image here"}],
    "explanations": [{"b64": "b64 encoded explained image here"}]
```

In the Deeploy UI, select "Trained explainer" and then "Integrated explainer". This is necessary to be able to visualize the output of the explainer.

## Create/update reference.json files in Deeploy contract
Make sure:
* config/config.properties is present and updated
* model-store/model.mar is present and updated
* Variables in create_update_reference.py correspond with blob and image storage of choice.
```
python create_update_reference.py
```

Now you are ready to commit your changes and create a deployment in Deeploy!
